﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGanttView;
using Infragistics.Win.UltraWinSchedule;

namespace GanttViewMVVM
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			this.taskTableAdapter.Fill(this.dataSet1.Task);
			this.projectTableAdapter.Fill(this.dataSet1.Project);

			this.ultraCalendarInfo1.DataBindingsForProjects.BindingContextControl = this;
			this.ultraCalendarInfo1.DataBindingsForProjects.DataSource = this.projectBindingSource;

			this.ultraCalendarInfo1.DataBindingsForProjects.AllPropertiesMember = "AllProperties";
			this.ultraCalendarInfo1.DataBindingsForProjects.IdMember = "_id";
			this.ultraCalendarInfo1.DataBindingsForProjects.KeyMember = "Key";
			this.ultraCalendarInfo1.DataBindingsForProjects.NameMember = "Name";
			this.ultraCalendarInfo1.DataBindingsForProjects.StartDateMember = "StartDate";

			this.ultraCalendarInfo1.DataBindingsForTasks.BindingContextControl = this;
			this.ultraCalendarInfo1.DataBindingsForTasks.DataSource = this.taskBindingSource;

			this.ultraCalendarInfo1.DataBindingsForTasks.AllPropertiesMember = "AllProperties";
			this.ultraCalendarInfo1.DataBindingsForTasks.IdMember = "_id";
			this.ultraCalendarInfo1.DataBindingsForTasks.NameMember = "Name";
			this.ultraCalendarInfo1.DataBindingsForTasks.ParentTaskIdMember = "ParentTaskId";
			this.ultraCalendarInfo1.DataBindingsForTasks.ProjectKeyMember = "ProjectKey";
			this.ultraCalendarInfo1.DataBindingsForTasks.StartDateTimeMember = "StartDateTime";

			if (ultraCalendarInfo1.Projects.Count == 1)
			{
				var project = new Project();
				project.Key = "project1";
				project.Name = "Project 1";
				ultraCalendarInfo1.Projects.Add(project);
			}

			ultraGanttView1.Project = ultraCalendarInfo1.Projects[1];
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			//projectBindingSource.EndEdit();
			//taskBindingSource.EndEdit();
			ultraCalendarInfo1.ResetDataBindingsForTasks();
			ultraCalendarInfo1.ResetDataBindingsForProjects();
			this.projectTableAdapter.Update(this.dataSet1.Project);
			this.taskTableAdapter.Update(this.dataSet1.Task);
		}
	}
}
